diff --git a/CHANGELOG.md b/CHANGELOG.md
index a7f5afa9..efe11aa6 100644
--- a/CHANGELOG.md
+++ b/CHANGELOG.md
@@ -15,6 +15,7 @@ Add `M-f`, `M-b`, and `M-d` support for REPL ([#569](https://github.com/mfikes/p
 - Update site docs for tab completion ([#545](https://github.com/mfikes/planck/issues/545))
 - Auto-completion fails with numbers in ns names ([#578](https://github.com/mfikes/planck/issues/578))
 - Terminal size changes not detected until line entered ([#584](https://github.com/mfikes/planck/issues/584))
+- Odd jump if you paste long line ([#459](https://github.com/mfikes/planck/issues/459))
 
 ## [2.10.0] - 2017-12-07
 ### Added
diff --git a/planck-c/repl.c b/planck-c/repl.c
index 518f3cff..59ecc813 100644
--- a/planck-c/repl.c
+++ b/planck-c/repl.c
@@ -5,6 +5,7 @@
 #include <string.h>
 #include <pthread.h>
 #include <unistd.h>
+#include <sys/ioctl.h>
 
 #include "linenoise.h"
 
@@ -417,6 +418,18 @@ void highlight(const char *buf, int pos) {
         if (num_lines_up != -1) {
             int relative_horiz = highlight_pos - current_pos;
 
+            int prompt_length = (int) strlen(s_repl->current_prompt);
+
+            struct winsize w;
+            int rv = ioctl(STDOUT_FILENO, TIOCGWINSZ, &w);
+            int terminal_width = rv == -1 ? 80 : w.ws_col;
+
+            if (current_pos + prompt_length + 1 > terminal_width) {
+                int extra_lines = (current_pos + prompt_length) / terminal_width;
+                relative_horiz = (relative_horiz + extra_lines * terminal_width) % terminal_width;
+                num_lines_up += extra_lines;
+            }
+
             if (num_lines_up != 0) {
                 fprintf(stdout, "\x1b[%dA", num_lines_up);
             }
